## Downloading OpenCLIPER

For the time being, we can only support GNU/Linux, but this may change in the future. All development and tests have been done in an Ubuntu 18.04 distribution.

Please send patches, requests, ideas, etc. to [opencliper@lpi.tel.uva.es](mailto:opencliper@lpi.tel.uva.es).

### Git repository

The code is available at [http://opencliper.lpi.tel.uva.es/OpenCLIPER](http://opencliper.lpi.tel.uva.es/OpenCLIPER).

To clone the repository, just type `git clone http://opencliper.lpi.tel.uva.es/OpenCLIPER`.

### Tar archive

If you are not used to git, you can download the [tar archive](/download/OpenCLIPER.tar.gz).

## Installing OpenCLIPER

### Dependencies

- GCC 5 or newer.
- [CMake](http://www.cmake.org). Version 2.8 or newer should work.
- [libmatio](https://github.com/telehan/libmatio) (for reading Matlab files). Available in Ubuntu repositories.
- [clFFT](https://github.com/clMathLibraries/clFFT).
- [clBLAST](https://cnugteren.github.io/clblast/clblast.html) (included in the git repository).
- [OpenCV](https://opencv.org/). Available in Ubuntu repositories.
- A functional OpenCL 1.2 implementation (we may support OpenCL 1.0 in the future, but not yet).
    - For nVidia GPUs, it comes with the [CUDA packages](https://developer.nvidia.com/cuda-downloads).
    - For AMD GPUs and CPUs, you may use [AMDGPU pro](https://support.amd.com/en-us/kb-articles/Pages/Radeon-Software-for-Linux-Release-Notes.aspx) (their proprietary implementation) or try [ROCm](https://rocm.github.io/) (the free alternative).
    - For Intel CPUs and GPUs, download their [OpenCL driver](https://software.intel.com/en-us/articles/opencl-drivers).

    
### Compiling

OpenCLIPER is developed as a [CMake](http://www.cmake.org) project, so, the typical compilation sequence is used:

```
tar xvfz OpenCLIPER.tar.gz
cd OpenCLIPER
mkdir build
cd build
cmake ..
make
```

Instead of cmake, you can use ccmake to tailor the compilation process to your needs.


## Getting started

Now that you have compiled OpenCLIPER (hopefully), it would be a great time to read the [tutorial](/tutorial) or have a look at the included tests and examples, and don't hesitate to [tell us](/contact) what you think of OpenCLIPER!
