/* Copyright (C) 2018 Federico Simmross Wattenberg,
 *                    Manuel Rodríguez Cayetano,
 *                    Javier Royuela del Val,
 *                    Elena Martín González,
 *                    Elisa Moya Sáez,
 *                    Marcos Martín Fernández and
 *                    Carlos Alberola López
 *
 * This file is part of OpenCLIPER.
 *
 * OpenCLIPER is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3 of the License.
 *
 * OpenCLIPER is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with OpenCLIPER; If not, see <http://www.gnu.org/licenses/>.
 *
 *
 *  Contact:
 *
 *  Federico Simmross Wattenberg
 *  E.T.S.I. Telecomunicación
 *  Universidad de Valladolid
 *  Paseo de Belén 15
 *  47011 Valladolid, Spain.
 *  fedsim@tel.uva.es
 */
/**
 * @file
 * @brief Label definitions for configuration of default datatypes
 */

// Calculus using floating point double precision if label defined
//#define DOUBLE_PREC

#ifdef NDEBUG
    /// Options for OpenCL command queues in release mode
    #define COMMANDQUEUEOPTIONS cl::QueueProperties::None
#else
    /// Options for OpenCL command queues in debug mode
    #define COMMANDQUEUEOPTIONS cl::QueueProperties::Profiling
#endif

/// Number of precision digits for time values using in profiling code
#define PROFILINGTIMESPRECISION 12
