/* Copyright (C) 2018 Federico Simmross Wattenberg,
 *                    Manuel Rodríguez Cayetano,
 *                    Javier Royuela del Val,
 *                    Elena Martín González,
 *                    Elisa Moya Sáez,
 *                    Marcos Martín Fernández and
 *                    Carlos Alberola López
 *
 * This file is part of OpenCLIPER.
 *
 * OpenCLIPER is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3 of the License.
 *
 * OpenCLIPER is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with OpenCLIPER; If not, see <http://www.gnu.org/licenses/>.
 *
 *
 *  Contact:
 *
 *  Federico Simmross Wattenberg
 *  E.T.S.I. Telecomunicación
 *  Universidad de Valladolid
 *  Paseo de Belén 15
 *  47011 Valladolid, Spain.
 *  fedsim@tel.uva.es
 */
#ifndef INCLUDE_OPENCLIP_SIMPLEMRIRECONSOS_HPP_
#define INCLUDE_OPENCLIP_SIMPLEMRIRECONSOS_HPP_

#include <OpenCLIPER/CLapp.hpp>
#include <OpenCLIPER/XData.hpp>
#include <OpenCLIPER/KData.hpp>
#include <OpenCLIPER/Process.hpp>
#include <OpenCLIPER/processes/FFT.hpp>
#include <OpenCLIPER/processes/RSoS.hpp>

namespace OpenCLIPER {

/// Class Data - Class that includes data and properties common to k-space and x-space images.
class SimpleMRIReconSOS: public Process {
    public:
        SimpleMRIReconSOS(): Process() {}
        SimpleMRIReconSOS(std::shared_ptr<OpenCLIPER::CLapp> pCLapp): Process(pCLapp) {};
        ~SimpleMRIReconSOS();

        void init();
        void launch(ProfileParameters profileParameters);

    private:
        std::unique_ptr<Process> pProcInvFFT;
	std::unique_ptr<Process> pRSoS;
	
	DataHandle auxHandle;
};

} //namespace OpenCLIPER

#endif /* INCLUDE_OPENCLIP_SIMPLEMRIRECONSOS_HPP_ */
