/* Copyright (C) 2018 Federico Simmross Wattenberg,
 *                    Manuel Rodríguez Cayetano,
 *                    Javier Royuela del Val,
 *                    Elena Martín González,
 *                    Elisa Moya Sáez,
 *                    Marcos Martín Fernández and
 *                    Carlos Alberola López
 *
 * This file is part of OpenCLIPER.
 *
 * OpenCLIPER is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3 of the License.
 *
 * OpenCLIPER is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with OpenCLIPER; If not, see <http://www.gnu.org/licenses/>.
 *
 *
 *  Contact:
 *
 *  Federico Simmross Wattenberg
 *  E.T.S.I. Telecomunicación
 *  Universidad de Valladolid
 *  Paseo de Belén 15
 *  47011 Valladolid, Spain.
 *  fedsim@tel.uva.es
 */
#ifndef INCLUDE_OPENCLIPER_INITZERORECT_HPP_
#define INCLUDE_OPENCLIPER_INITZERORECT_HPP_
#include <OpenCLIPER/Process.hpp>
#include <OpenCLIPER/CLapp.hpp>
#include <OpenCLIPER/XData.hpp>

namespace OpenCLIPER {

/**
 * @brief Process class to fill a rectangular region of a 2D+t array
 *        with zeros (i.e. clear a region of the array)
 *       
 */
class InitZeroRect: public Process {
    public:
        
        struct LaunchParameters:Process::LaunchParameters {
        int* bound_box;
        
        LaunchParameters(int* bound_box): bound_box(bound_box) {}
        };
        
        InitZeroRect(): Process() {}
        InitZeroRect(std::shared_ptr<OpenCLIPER::CLapp> pCLapp): Process(pCLapp) {};
        void launch(ProfileParameters profileParameters = {false, 1});
        void init();
        
    private:
        cl::Buffer r1marginobj;
        cl::Buffer r2marginobj;
        
};
  
} /* namespace OpenCLIPER */

#endif /* INCLUDE_OPENCLIPER_INITZERORECT_HPP_ */
