#!/usr/bin/env bash
if [ "$#" -lt "4" ]; then
   echo "Usage: $0 size iterations namePrefix outputDir"
else
    size=$1
    iterations=$2
    namePrefix=$3
    outputDir=$4
    outputFileName=${outputDir}/arrayAddTests_${namePrefix}_size${size}_iterations${iterations}.csv
    touch ${outputFileName}
    for command in arrayAddSerial arrayAddOpenMP_CPU arrayAddOpenCLIPER_CPU arrayAddOpenCLIPER_GPU arrayAddCUDA
    do
        outputFileNameIteration=${outputDir}/${command}_${namePrefix}_size${size}_iterations${iterations}.csv
        if [ "$command" = "arrayAddSerial" ]; then 
            ./$command -r $iterations -a $size -f 2 -o ${outputFileNameIteration}
        else
            ./$command -r $iterations -a $size -f 1 -o ${outputFileNameIteration}
        fi
		   cat ${outputFileNameIteration} >> ${outputFileName}
    done
fi

