#!/usr/bin/env bash
if [ "$#" -lt "5" ]; then
   echo "Usage: $0 size maxBlockSize iterations namePrefix outputDir"
else
    size=$1
    maxBlockSize=$2
    iterations=$3
    namePrefix=$4
    outputDir=$5
    outputFileName=${outputDir}/arrayAddTests_${namePrefix}_size${size}_iterations${iterations}_blockAnaylsis.csv
    touch ${outputFileName}
    for command in arrayAddOpenCLIPER_GPU arrayAddCUDA
    do
	blockSize=1
	while [ $blockSize -le $maxBlockSize ]
	do
	    echo "blockSize: $blockSize"
	    outputFileNameIteration=${outputDir}/${command}_${namePrefix}_size${size}_iterations${iterations}_block${blockSize}.csv
	    ./$command -r $iterations -a $size -f 1 -o ${outputFileNameIteration} -b ${blockSize}
	    cat ${outputFileNameIteration} >> ${outputFileName}
	    blockSize=$((blockSize*2))
	done
    done
fi

