#!/usr/bin/env bash
if [ "$#" -lt "5" ]; then
   echo "Usage: $0 minArraySize maxArraySize iterations namePrefix outputDir"
else
    minArraySize=$1
    maxArraySize=$2
    iterations=$3
    namePrefix=$4
    outputDir=$5
    size=$minArraySize
    outputFileName=${outputDir}/arrayAddTests_${namePrefix}_minSize${minArraySize}_maxSize${maxArraySize}_iterations${iterations}.csv
    touch ${outputFileName}
    while [ $size -le $maxArraySize ]; do
	outputFileNameSize=${outputDir}/arrayAddTests_${namePrefix}_size${size}_iterations${iterations}.csv
	touch ${outputFileNameSize}
	for command in arrayAddSerial arrayAddOpenMP_CPU arrayAddOpenCLIPER_CPU arrayAddOpenCLIPER_GPU arrayAddCUDA
	do
            outputFileNameIteration=${outputDir}/${command}_${namePrefix}_size${size}_iterations${iterations}.csv
            if [ "$command" = "arrayAddSerial" ]; then 
		./$command -r $iterations -a $size -f 2 -o ${outputFileNameIteration}
            else
		./$command -r $iterations -a $size -f 1 -o ${outputFileNameIteration}
            fi
	    cat ${outputFileNameIteration} >> ${outputFileNameSize}
	    \rm ${outputFileNameIteration}
	done
	cat ${outputFileNameSize} >> ${outputFileName}
	size=$(( size * 2 ))
    done
fi

