#!/usr/bin/env bash
if [ "$#" -lt "4" ]; then
   echo "Usage: $0 size iterations namePrefix outputDir"
else
    size=$1
    iterations=$2
    namePrefix=$3
    outputDir=$4
    outputFileName=${outputDir}/arrayMultTests_${namePrefix}_size${size}_iterations${iterations}.csv
    touch ${outputFileName}
    for command in arrayMultSerial arrayMultOpenMP_CPU arrayMultOpenCLIPER_CPU arrayMultOpenCLIPER_GPU arrayMultCUDA
    do
		   outputFileNameIteration=${outputDir}/${command}_${namePrefix}_size${size}_iterations${iterations}.csv
		   ./$command -i $iterations -s $size -f 1 -o ${outputFileNameIteration}
		   cat ${outputFileNameIteration} >> ${outputFileName}
    done
fi

