// Para control de versiones con RCS/CVS
// $Id: vector_utils.hpp,v 1.5 2016/09/28 17:20:38 manrod Exp $
const char vector_utils_hpp_RCSId[] =
  "$Id: vector_utils.hpp,v 1.5 2016/09/28 17:20:38 manrod Exp $";

#include <vector>
#include <iostream>
#include <fstream>
#include <iterator>
#include <string>
#include <sstream>

using namespace std;

/**
 * Funcin para mostrar un vector de un tipo base genrico.
*/
template <typename vector_type>
void print_vector(string name, std::vector<vector_type> v,
			 unsigned long show_size);

/**
 * Funcin para mostrar una fila de una matriz de un tipo base genrico.
 */
template <typename array_type>
void print_array_row (array_type array[], int columns,
		      unsigned long show_size);

/**
 * Funcin para mostrar una matriz de un tipo base genrico.
 */
template <typename array_type>
void print_array (string name, array_type array[], int rows, int columns,
		    int show_size);

/**
 * Clase que representa a una matriz donde sus elementos se almacenan fila a 
 * fila en un vector (para que no haya que hacer conversiones al usarlo como 
 * fuente de datos para matrices opencl, que se representan como vectores
 */
template <class elementType> class Matrix {
public:
  // Constructores
  Matrix(unsigned long rows, unsigned long cols);
  Matrix(unsigned long rows, unsigned long cols, elementType value);
  //Matrix(const Matrix <elementType>&);
  Matrix(unsigned long rows, unsigned long cols, elementType *initialArray);
  // Destructor
  ~Matrix();
  // Devuelve el nmero de filas de la matriz
  unsigned long getNumberOfRows(void);
  // Devuelve el nmero de columnas de la matriz
  unsigned long getNumberOfCols(void);
  // Devuelve la matriz con los elementos (almacenados fila a fila como un vector)
 elementType * data(void);
  // Muestra el contenido de la matriz,  pudiendo limitar el nmero de elementos
  // mostrado por fila y/o por clumunas
  string toString(string name, unsigned long rowShowSize,
		  unsigned long colShowSize);
  void copy(Matrix<elementType> sourceMatrix);
private:
  // Vector con los elementos de la matriz almacenados fila a fila
  vector<elementType> elements;
  // Nmero de filas y de columnas
  unsigned long rows, cols;
};

